# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from jdcloud_sdk.core.jdcloudrequest import JDCloudRequest


class UpdateMetricTaskRequest(JDCloudRequest):
    """
    更新监控任务，日志监控任务不许重名。
    """

    def __init__(self, parameters, header=None, version="v1"):
        super(UpdateMetricTaskRequest, self).__init__(
            '/regions/{regionId}/logsets/{logsetUID}/logtopics/{logtopicUID}/metrictasks/{logmetrictaskUID}', 'PUT', header, version)
        self.parameters = parameters


class UpdateMetricTaskParameters(object):

    def __init__(self, regionId, logsetUID, logtopicUID, logmetrictaskUID, customUnit, filterOpen, filterType, name, unit):
        """
        :param regionId: 地域 Id
        :param logsetUID: 日志集 UID
        :param logtopicUID: 日志主题 UID
        :param logmetrictaskUID: 
        :param customUnit: 自定义单位
        :param filterOpen: 是否打开过滤
        :param filterType: 过滤类型，只能是fulltext和 advance
        :param name: 监控任务名称,同一日志主题下唯一，支持中文 大小写英文字母 下划线 中划线 数字，且不超过32
        :param unit: 单位
        """

        self.regionId = regionId
        self.logsetUID = logsetUID
        self.logtopicUID = logtopicUID
        self.logmetrictaskUID = logmetrictaskUID
        self.customUnit = customUnit
        self.filterContent = None
        self.filterOpen = filterOpen
        self.filterType = filterType
        self.name = name
        self.unit = unit

    def setFilterContent(self, filterContent):
        """
        :param filterContent: (Optional) 过滤语法，可以为空
        """
        self.filterContent = filterContent

